unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
   SMenu: HMenu;
   AddingItem: Boolean;
   procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
   procedure EnableButton(Enable: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
Id_my = $00a0;

procedure TForm1.FormCreate(Sender: TObject);
begin
 SMenu := GetSystemMenu(HAndle,false);
// Appendmenu(SMenu,mf_string,Id_My,'...')
{AppendMenu   . 16-bit}
end;

procedure TForm1.WMSysCommand(var Msg: TWMSysCommand);
begin
if Msg.CmdType = Id_My then
 ShowMessage('     .');
inherited;
end;

procedure TForm1.Button1Click(Sender: TObject);
var mi: TMenuItemInfo;
begin
 mi.cbSize := 44;
 {!   Sizeof(mi)   }
 mi.fMask := MIIM_DATA or MIIM_ID or MIIM_STATE	or MIIM_TYPE;
 mi.fType := MFT_STRING;
 mi.fState := MFS_ENABLED;
 mi.wID := Id_my;
 mi.hSubMenu := 0;
 mi.hbmpChecked := 0;
 mi.hbmpUnchecked := 0;
 mi.dwTypeData := PChar('C &');
 AddingItem := InsertMenuItem(SMenu,1,True,Mi);
 EnableButton(AddingItem);
end;

procedure TForm1.EnableButton(Enable: Boolean);
begin
 Button1.Enabled := not Enable;
 Button2.Enabled := Enable;
 Button3.Enabled := Enable;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 EnableMenuItem(SMenu,Id_My,MF_BYCOMMAND or MF_Grayed);
 Button2.Enabled := False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 DeleteMenu(SMenu,id_My, MF_BYCOMMAND);
 AddingItem := False;
 EnableButton(AddingItem);
end;

end.
